#!/usr/bin/env bash
set -e

#Number of iterations
NUMIMAGES=$1
IMAGE=$2
operation=$3
FILESIZE=$4
NUMLAYERS=$5

#URL Settings
REGISTRYPROTO=https://
REGISTRYHOST=privateregistry.com
REGISTRYPORT=5000
REGISTRYURL=$REGISTRYHOST:$REGISTRYPORT
FULLREGISTRYURL=$REGISTRYPROTO$REGISTRYURL
#echo "Registry: $FULLREGISTRYURL"

#CSV Header
echo "Running Process.."
#ssh master /root/registry/monitorcpuperformance.sh 1 1


if [ "$operation" == "5" ]
then
     	printf $"Cleaning up....\n"
	#remove image
        rm blankfile*
        rm $IMAGE
        echo "" > softdelete.txt
fi

if [ "$operation" == "0" ]
then
	printf $"Building large file....\n"
	dd if=/dev/urandom of=$IMAGE bs=10M count=$FILESIZE 
else
 #create a common layer
 #echo "1" > blankfile1
 #Run a loop for 1:NUMIMAGES
 for (( IMGNUM=1; IMGNUM<=$NUMIMAGES; IMGNUM++))
 do
	
	if [ "$operation" == "1" ]
	then
		printf $"Building Dockerfile....\n"
		echo "FROM scratch" > Dockerfile
		#create a common layer
		#echo 'COPY ["'$IMAGE'", "blankfile1", "/"]' >> Dockerfile
		for (( randnum=1; randnum<=$NUMLAYERS; randnum++))
		do
		  echo $RANDOM > blankfile$randnum
		  echo 'COPY ["'$IMAGE'", "blankfile'$randnum'", "/"]' >> Dockerfile
		done
		#Build a fresh image
		printf $"Building image - $IMGNUM ....\n"
		docker build --rm --no-cache -t $IMAGE-$IMGNUM . 
	elif [ "$operation" == "2" ]
	then
		printf $"Tagging image $IMAGE-$IMGNUM....\n"
		#Tag image
		docker tag $IMAGE-$IMGNUM $REGISTRYURL/$IMAGE-$IMGNUM #&
	elif [ "$operation" == "3" ]
        then
		printf $"Pushing image $IMAGE-$IMGNUM....\n"
		#Push image
		docker push $REGISTRYURL/$IMAGE-$IMGNUM #&
	elif [ "$operation" == "4" ]
	then
		#echo "" > softdelete.txt
		printf $"Soft deleting image $IMAGE-$IMGNUM....\n"
		curl -k -X GET "$FULLREGISTRYURL/delete?image=$IMAGE-$IMGNUM&tag=latest" >> softdelete.txt
	elif [ "$operation" == "5" ]
	then
		printf $"Cleaning up....\n"
		#remove image
		docker rmi -f $IMAGE-$IMGNUM >/dev/null
		docker rmi -f $REGISTRYURL/$IMAGE-$IMGNUM >/dev/null
		docker volume ls -qf dangling=true | xargs -r docker volume rm >/dev/null
	else
 	 	printf $"invalid operation \n"
	fi
 done
fi

